diff deploy/osx/paths.sh @ 672:88fa1544b407

Merge from branch qt5. There's much more to be done before we can make another release, but clearly it's going to be done using qt5
author Chris Cannam
date Wed, 05 Dec 2018 09:44:10 +0000
parents 8f3075eeaac2
children 646e48a0d3a5
line wrap: on
line diff
--- a/deploy/osx/paths.sh	Wed Mar 23 14:49:49 2016 +0000
+++ b/deploy/osx/paths.sh	Wed Dec 05 09:44:10 2018 +0000
@@ -1,5 +1,7 @@
 #!/bin/bash
 
+set -e
+
 app="$1"
 if [ -z "$app" ]; then
 	echo "Usage: $0 <appname>"
@@ -7,28 +9,68 @@
 	exit 2
 fi
 
+set -u
+
+frameworks="QtCore QtNetwork QtGui QtWidgets QtPrintSupport QtDBus"
+
 echo
-echo "I expect you to have already copied QtCore, QtNetwork and QtGui to "
-echo "$app.app/Contents/Frameworks and PyQt4/QtCore.so and PyQt4/QtGui.so to "
-echo "$app.app/Contents/MacOS -- expect errors to follow if they're missing"
+echo "I expect you to have already copied these frameworks from the Qt installation to"
+echo "$app.app/Contents/Frameworks -- expect errors to follow if they're missing:"
+echo "$frameworks"
 echo
 
 echo "Fixing up loader paths in binaries..."
 
-install_name_tool -id QtCore "$app.app/Contents/Frameworks/QtCore"
-install_name_tool -id QtGui "$app.app/Contents/Frameworks/QtGui"
-install_name_tool -id QtNetwork "$app.app/Contents/Frameworks/QtNetwork"
+for fwk in $frameworks; do
+    install_name_tool -id $fwk "$app.app/Contents/Frameworks/$fwk"
+done
 
-for fwk in QtCore QtGui QtNetwork; do
-        find "$app.app" -type f -print | while read x; do
-                current=$(otool -L "$x" | grep "$fwk" | grep ramework | awk '{ print $1; }')
-                [ -z "$current" ] && continue
-                echo "$x has $current"
-                relative=$(echo "$x" | sed -e "s,$app.app/Contents/,," \
-                        -e 's,[^/]*/,../,g' -e 's,/[^/]*$,/Frameworks/'"$fwk"',' )
-                echo "replacing with relative path $relative"
-                install_name_tool -change "$current" "@loader_path/$relative" "$x"
-        done
+find "$app.app" -name \*.dylib -print | while read x; do
+    install_name_tool -id "`basename \"$x\"`" "$x"
+done
+
+for fwk in $frameworks; do
+    find "$app.app" -type f -print | while read x; do
+
+        current=$(otool -L "$x" | 
+	    grep "$fwk" | grep amework | grep -v ':$' | 
+	    awk '{ print $1; }')
+	
+        [ -z "$current" ] && continue
+	
+        echo "$x has $current"
+	
+	case "$x" in
+	    *PyQt4*)
+		# These are "special" Qt4 libraries used by
+		# the PyQt module. They need to refer to their
+		# own local neighbours. Ugh, but let's handle
+		# those manually here.
+		relative="$fwk.so"
+		;;
+	    *)
+		# The normal Qt5 case
+		relative=$(echo "$x" | 
+		    sed -e "s,$app.app/Contents/,," \
+			-e 's,[^/]*/,../,g' \
+			-e 's,/[^/]*$,/Frameworks/'"$fwk"',' )
+		;;
+	esac
+	
+	echo "replacing with relative path $relative"
+	install_name_tool -change \
+	    "$current" "@loader_path/$relative" "$x"
+    done
+done
+
+find "$app.app" -type f -print | while read x; do
+    qtdep=$(otool -L "$x" | grep Qt | grep amework | grep -v ':$' | grep -v '@loader_path' | awk '{ print $1; }')
+    if [ -n "$qtdep" ]; then
+	echo
+	echo "ERROR: File $x depends on Qt framework(s) not apparently present in the bundle:"
+	echo $qtdep
+	exit 1
+    fi
 done
 
 echo "Done: be sure to run the app and see that it works!"